#ifndef __gacpp_h__
#define __gacpp_h__


#include "sstmac/common/sstmac-config.h"

#include "ftypes.h"

#if DEBUG
#define DEBUG_PRINT(FORMAT, ...) printf("(%d) " FORMAT, getNodeID(), ##__VA_ARGS__)
#else
#define DEBUG_PRINT(FORMAT, ...)
#endif

#ifdef __cplusplus
extern "C" {
#endif

  Integer gaCreateHandle();
  void tascelInit();
  void tascelFinalize();
  void gaCreate(Integer g_a, Integer ndim, Integer *dims, Integer type);
  void gaDestroy(Integer g_a);
  void gaZero(Integer g_a);
  Integer gaReadInc(Integer g_a, Integer subscript, Integer inc);
  Integer getNodeID();
  Integer getNProc();
  void amBarrier();
  void gaPut(Integer g_a, Integer *lo, Integer *hi, void *buf, Integer *ld);
  void gaPutI(int g_a, int *lo, int *hi, void *buf, int *ld);
  void gaGet(Integer g_a, Integer *lo, Integer *hi, void *buf, Integer *ld);
  void gaGetI(int g_a, int *lo, int *hi, void *buf, int *ld);
  void gaAcc(Integer g_a, Integer *lo, Integer *hi, void *buf, Integer *ld);
  void gaAccI(int g_a, int *lo, int *hi, void *buf, int *ld);
  void gaSymmetrize(Integer g_a);
  void gaDiagSeq(Integer g_a, Integer g_s, Integer g_v, DoublePrecision *eval);
  void gaDiagStdSeq(Integer g_a, Integer g_v, DoublePrecision *eval);
  void gaDgemm(char* transa, char* transb, Integer m, Integer n, Integer k,
	       DoublePrecision* alpha, Integer g_a, Integer g_b,
	       DoublePrecision* beta, Integer g_c, int talen, int tblen);
  void gaCopy(Integer g_a, Integer g_b);
  void gaAdd(DoublePrecision alpha, Integer g_a, DoublePrecision beta,
	     Integer g_b, Integer g_c);
#ifdef __cplusplus
}
#endif

#endif /* __gacpp_h__ */
