#include <sstmac/sstsockets.h>

void run_client()
{
    int sock;
    struct sockaddr_in sa;
    int bytes_sent;
    char buffer[] = { "here is an example message" };

    //create an internet, datagram, socket using UDP
    sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if (-1 == sock) /* if socket failed to initialize, exit */
    {
        fprintf(stderr, "Error creating client socket");
        return;
    }

    //The address is ipv4
    sa.sin_family = AF_INET;

    //ip_v4 adresses is a uint32_t, convert a std::string representation of the octets to the appropriate value
    sa.sin_addr.s_addr = get_hostaddr(0); //the server will be task 0

    //sockets are unsigned shorts, htons(x) ensures x is in network byte order, set the port to 7654
    sa.sin_port = htons(7654);

    bytes_sent = sendto(sock, buffer, strlen(buffer), MSG_DONTWAIT, (struct sockaddr*)&sa, sizeof(sa));
    if (bytes_sent < 0) {
        fprintf(stderr, "Error sending packet: %s\n", strerror(errno));
    }
    else {
        printf("Sent %d bytes on task id %ld\n", bytes_sent, sa.sin_addr.s_addr);
        close(sock); /* close the socket */
    }

    //create an internet, datagram, socket using UDP
    sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if (-1 == sock) /* if socket failed to initialize, exit */
    {
        fprintf(stderr, "Error creating client socket");
        return;
    }
    /** now send three messages of size 24 for the server to recv 72 bytes */
    for (int i=0; i < 3; ++i){
        bytes_sent = sendto(sock, buffer, 24, 0,(struct sockaddr*)&sa, sizeof(sa));
        if (bytes_sent < 0) {
            fprintf(stderr, "Error sending packet: %s\n", strerror(errno));
        }
        else {
            printf("Sent %d bytes on task id %ld\n", bytes_sent, sa.sin_addr.s_addr);
        }
    }
    close(sock); /* close the socket */


}


