/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_NATIVE_DRIVER_H_INCLUDED
#define SSTMAC_BACKENDS_NATIVE_DRIVER_H_INCLUDED

#include <sstmac/common/driver_util.h>
#include <sstmac/common/config.h>

#include <sstmac/backends/native/eventlist.h>
#include <sstmac/backends/native/eventmap.h>
#include <sstmac/backends/native/manager.h>
#include <sstmac/backends/native/managerdegraded.h>

//node models
#include <sstmac/hardware/node/simplenode.h>

//nic models
#include <sstmac/hardware/nic/simplenic.h>

//event managers
#include <sstmac/backends/native/eventmap.h>

#include <sstmac/software/services/launch/allocation/allocationstrategy.h>

namespace sstmac
{
  namespace native
  {

    void
    clear_statics();

    eventmanager::ptr
    driver_run(const sim_parameters::ptr &params, timestamp until, bool print);

  }
}

#endif
