/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2011 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/backends/native/ip_queue.h>
#include <sstmac/hardware/network/interconnect/interconnect.h>
namespace sstmac
{
  namespace native
  {
    debug ip_queue::dbg_;

    timestamp ip_queue::bigtime(1000000);

    ip_queue::ip_queue(lppath coords) :
      path_(coords)
    {
      if (!dbg_.is_real())
      {
        dbg_ = debug("<debug> parallel | ip_queue");
        logger::register_logger(&dbg_);
      }
    }

    void
    ip_queue::set_switches(const boost::intrusive_ptr<hw::interconnect> &fab)
    {

    }

  }
}
