/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_COMMON_DEBUG_H_INCLUDED
#define SSTMAC_COMMON_DEBUG_H_INCLUDED

#include <sstmac/common/sstmac-config.h>
#include <sstmac/common/logger.h>

namespace sstmac {

#if SSTMAC_ENABLE_DEBUG
#define SSTMAC_DEBUG if(dbg_.is_active()) dbg_ << dbg_.time()
#define SSTMAC_DEBUG2 if(dbg_.is_active(2)) dbg_ << dbg_.time()
#define SSTMAC_DEBUG3 if(dbg_.is_active(3)) dbg_ << dbg_.time()
#define SSTMAC_DEBUG4 if(dbg_.is_active(4)) dbg_ << dbg_.time()
#else
#define SSTMAC_DEBUG if(0) dbg_
#define SSTMAC_DEBUG2 if(0) dbg_
#define SSTMAC_DEBUG3 if(0) dbg_
#define SSTMAC_DEBUG4 if(0) dbg_
#endif
  /**
   * Just a dummy base class for debug type loggers.
   */
class debug : public logger
{
public:

  static std::ostream *debug_stream_;

  debug(std::string namesig, const char* color = logger::black) :
      logger(namesig, debug_stream_, true, color)
  {
  }

  debug() : logger() {}  // use this for static variables, then create a new one later


};

} // end of namespace sstmac




#endif
