/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/common/eventhandler.h>

namespace sstmac {

  eventhandler::ptr eventhandler::ignore(new donothinghandler());


  eventhandler::eventhandler()
  {
  }

  eventhandler::~eventhandler()
  {
  }

  donothinghandler::ptr
  donothinghandler::construct()
  {
      return new donothinghandler;
  }

  std::string
  donothinghandler::to_string() const
  {
    return "donothinghandler";
  }

  void
  donothinghandler::handle(const sst_message::ptr &msg)
  {
  }



} // end of namespace sstmac
