/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */
#include <sstmac/common/sstmac_env.h>

namespace sstmac
{
  sim_parameters::ptr sstmac_env::params = 0;
  sstmac_env::RUN_TYPES sstmac_env::run_mode_ = sstmac_env::SHARED_MEMORY;
  eventmanager::ptr sstmac_env::evman_ = 0;

  void
  sstmac_env::end_gracefully()
  {
    if(run_mode_ == DIST_PARALLEL)
      evman_->end_gracefully();
  }
}
