/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_COMMON_SSTMAC_ENV_H_INCLUDED
#define SSTMAC_COMMON_SSTMAC_ENV_H_INCLUDED

#include <sstmac/common/ptr_type.h>
#include <sstmac/common/sim_parameters.h>
#include <sstmac/common/eventmanager.h>
//#include <sstmac/backends/native/dist_eventmap.h>

namespace sstmac
{

 /* class run_info : public ptr_type
  {

  protected:
    run_info()
    {

    }
  public:
    typedef boost::intrusive_ptr<run_info> ptr;

    static ptr
    construct()
    {
      return ptr(new run_info());
    }

    virtual
    ~run_info()
    {
    }

    virtual std::string
    to_string() const
    {
      return "run_info";
    }
  };
  */

  /**
   * Holds partition information
   */
 /* class threadpar_run_info : public run_info
  {
  protected:
    threadpar_run_info(native::dist_eventmap::ptr e) : ev_(e)
    {

    }

    native::dist_eventmap::ptr ev_;

  public:
    typedef boost::intrusive_ptr<threadpar_run_info> ptr;

    static ptr
    construct(native::dist_eventmap::ptr e)
    {
      return ptr(new threadpar_run_info(e));
    }

    virtual
    ~threadpar_run_info()
    {
    }

    native::ip_queue::ptr
    get_ip_queue(const nodeaddress::ptr &addr){
      return ev_->get_ip_queue(addr);
    }

    virtual std::string
    to_string() const
    {
      return "threadpar_run_info";
    }
  };*/


  /**
   * This class holds some global information about the simulation
   */
  class sstmac_env
  {
  public:
    enum RUN_TYPES
    {
      SHARED_MEMORY, THREAD_PARALLEL, DIST_PARALLEL
    };
    static RUN_TYPES run_mode_;
   // static run_info::ptr run_info_;
    static sim_parameters::ptr params;

    static eventmanager::ptr evman_;
    static void
    end_gracefully();
  };

}
#endif
