#ifndef sstmac_hardware_memory_NULL_MEMORYMODEL_H
#define sstmac_hardware_memory_NULL_MEMORYMODEL_H

#include <sstmac/hardware/memory/memorymodel.h>
#include <sstmac/hardware/node/node.h>

namespace sstmac { namespace hw
{

  class null_memorymodel :
    public memorymodel
  {
  protected:
    null_memorymodel();

  public:
    typedef boost::intrusive_ptr<null_memorymodel> ptr;

    static ptr
    construct(const sim_parameters::ptr& params);

    virtual
    ~null_memorymodel();

    virtual void finish();

    virtual void handle(const sst_message::ptr &msg);

    virtual void access(const sst_message::ptr &msg);

  };

} } /* namespace sstmac */

#endif // NULL_MEMORYMODEL_H
