#include <sstmac/hardware/network/network_message.h>

DeclareSerializable(sstmac::hw::network_message);

namespace sstmac {
    namespace hw {

network_message::network_message()
    : sst_message(NETWORK),
    needs_ack_(true),
    route_algo_(routing_info::system_default)
{
}

network_message::network_message(const nodeaddress::ptr& to, const nodeaddress::ptr& from)
    : sst_message(NETWORK),
    needs_ack_(true),
    route_algo_(routing_info::system_default),
    toaddr_(to),
    fromaddr_(from)
{
}

network_message::ptr
network_message::construct()
{
    return new network_message;
}

network_message::ptr
network_message::construct(const nodeaddress::ptr &toaddr, const nodeaddress::ptr &fromaddr)
{
    return new network_message(toaddr, fromaddr);
}


void
network_message::serialize_order(sst_serializer *ser)
{
    sst_message::serialize_order(ser);
    ser->do_primitive(needs_ack_);
    ser->do_enum(route_algo_);
    ser->do_obj(toaddr_);
    ser->do_obj(fromaddr_);
}


    }
}


