#ifndef sstmac_hardware_network_topology_routing_ALGORITHM_H
#define sstmac_hardware_network_topology_routing_ALGORITHM_H

#include <sstmac/common/factories/factory.h>
#include <sstmac/hardware/network/interconnect/interconnect_message.h>
#include <sstmac/hardware/network/topology/topology.h>

namespace sstmac {
    namespace hw {

class routing_algorithm :
    public factory_type
{
    protected:
        static debug dbg_;

        routing_algorithm();

    public:
        typedef boost::intrusive_ptr<routing_algorithm> ptr;
        typedef boost::intrusive_ptr<const routing_algorithm> const_ptr;

        virtual int route(const interconnect_message::ptr& msg) = 0;

        virtual int get_number_paths(const interconnect_message::ptr& msg) const {
          return 1;
        }

        virtual void set_switch(const networkswitchPtr& sw) = 0;

        virtual void init_routing(const interconnect_message::ptr& msg) const = 0;

        virtual ~routing_algorithm(){}



};

DeclareFactory(routing_algorithm);


    }
}


#endif // ALGORITHM_H
