#ifndef SSTMAC_HARDWARE_NETWORK_ROUTING_ROUTER_MINAD_ROUTER_H
#define SSTMAC_HARDWARE_NETWORK_ROUTING_ROUTER_MINAD_ROUTER_H

#include <sstmac/hardware/network/topology/routing/basic_routing.h>

namespace sstmac {
    namespace hw{

class min_ad_routing_info :
    public minimal_routing_info
{
    public:
      typedef boost::intrusive_ptr<min_ad_routing_info> ptr;

      virtual routing_algorithm_t
      route_algo() const {
          return minimal_adaptive;
      }

      static ptr
      construct(){
        return new min_ad_routing_info;
      }

      virtual routing_info::ptr
              clone(){
        return construct();
      }

};

class minimal_adaptive_routing :
    public minimal_routing
{
    protected:

    public:
        typedef boost::intrusive_ptr<minimal_adaptive_routing> ptr;

        static ptr
        construct(const sim_parameters::ptr &params){
            return new minimal_adaptive_routing;
        }

        virtual int
        route(const interconnect_message::ptr &msg);

        virtual void
        init_routing(const interconnect_message::ptr &msg) const;
};




    }
}


#endif // MINAD_ROUTER_H
