/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/hardware/network/topology/routing/routing_info.h>
#include <sstmac/hardware/network/topology/routing/router.h>

  DeclareBaseClassSerializable(sstmac::hw::routing_info);

    DeclareSerializable(sstmac::hw::minimal_routing_info);

namespace sstmac
{
  namespace hw
  {

#define enumcase(x) case x: return #x
    const char*
    routing_info::tostr(routing_algorithm_t algo)
    {
        switch(algo)
        {
            enumcase(minimal);
            enumcase(valiant);
            enumcase(minimal_adaptive);
            enumcase(fully_adaptive);
            enumcase(system_default);
            enumcase(basic);
            enumcase(ugal);
            default:
                sst_throw(valueerror,
                    "invalud routing algorithm enum %d",
                     algo);
        }
        return 0;
    }


  }
}
