#include <sstmac/hardware/nic/nullnic.h>

namespace sstmac {
    namespace hw {

SSTRegister("nullnic | null", networkinterface, nullnic,
            "Implements a nic which immediately injects messages with no memory reads or latency");

void
nullnic::recv(const sst_message::ptr &netmsg)
{
    SSTMAC_DEBUG << sstprintf("nullnic::send: %s receiving message %s\n",
                              get_parent_id()->to_string().c_str(),
                              netmsg->to_string().c_str());
    parent_->handle(netmsg);
}

void
nullnic::send(const sst_message::ptr &payload)
{
    SSTMAC_DEBUG << sstprintf("nullnic::send: %s sending message %s\n",
                              get_parent_id()->to_string().c_str(),
                              payload->to_string().c_str());
    injector_->handle(payload);
}

networkinterface::ptr
nullnic::clone(const node::ptr &parent,
    const sstmac::hw::interconnect::ptr &interconn,
    const sim_parameters::ptr& params) const
{
  nullnic::ptr ret = nullnic::construct(params);
  ret->init(parent, interconn);
  return ret;
}

    }
}
