#include <sstmac/hardware/packetflow/packetflow_endpoint.h>
#include <sstmac/common/eventcallback.h>

namespace sstmac {
    namespace hw {

packetflow_endpoint::packetflow_endpoint()
{
}

void
packetflow_endpoint::handle(const sst_message::ptr &msg)
{
    packetflow_payload::ptr fmsg = safe_cast(msg, packetflow_payload);
    long& num_bytes_left = bytes_recved_[fmsg->msg_id()];
    if (num_bytes_left == 0) {
        num_bytes_left = fmsg->orig()->get_byte_length();
        schedule_unload(fmsg);
    }
    else {
        schedule_unload(fmsg);
    }
}

void
packetflow_endpoint::schedule_unload(const packetflow_payload::ptr& msg)
{
    schedule_delay(
        timestamp(msg->ser_delay()),
        new_event(ptr(this), &packetflow_endpoint::unload, msg));
}

void
packetflow_endpoint::unload(const packetflow_payload::ptr &msg)
{
      std::map<long, long>::iterator it = bytes_recved_.find(msg->msg_id());
      long& num_bytes_left = it->second;
      num_bytes_left -= msg->num_bytes();
      if (num_bytes_left == 0)
      {
          bytes_recved_.erase(it);
          exit_->handle(msg->orig());
      }
}

    }
}
