#ifndef PACKETFLOW_ENDPOINT_H
#define PACKETFLOW_ENDPOINT_H

#include <sstmac/common/eventmodule.h>
#include <sstmac/hardware/packetflow/packetflow.h>
#include <sstmac/hardware/packetflow/packetflow_handler.h>

namespace sstmac {
    namespace hw {

class packetflow_endpoint :
    public eventmodule
{
    protected:
        std::map<long, long> bytes_recved_;

        eventhandler::ptr exit_;

        packetflow_handler::ptr input_;

        packetflow_endpoint();

        void unload(const packetflow_payload::ptr& msg);

        void schedule_unload(const packetflow_payload::ptr& msg);

    public:
        typedef boost::intrusive_ptr<packetflow_endpoint> ptr;

        virtual ~packetflow_endpoint(){}

        static ptr
        construct(){
            return new packetflow_endpoint;
        }

        virtual void
        handle(const sst_message::ptr &msg);

        void
        set_exit(const eventhandler::ptr& handler){
            exit_ = handler;
        }

        void
        set_input(const packetflow_handler::ptr& handler){
            input_ = handler;
        }

};


    }
}

#endif // PACKETFLOW_ENDPOINT_H
