#include <sstmac/hardware/packetflow/packetflow_handler.h>

namespace sstmac {
    namespace hw {

debug packetflow_handler::dbg_;

packetflow_handler::packetflow_handler()
{
    if (!dbg_.is_real()){
        dbg_ = debug("<debug> packetflow");
    }
}

void
packetflow_handler::handle(const sst_message::ptr &msg)
{
    packetflow_message::ptr fmsg = safe_cast(msg, packetflow_message);
    switch (fmsg->type())
    {
        case packetflow_message::credit:
            handle_credit(boost::static_pointer_cast<packetflow_credit>(fmsg));
            break;
        case packetflow_message::payload:
            handle_payload(boost::static_pointer_cast<packetflow_payload>(fmsg));
            break;
    }
}

void
packetflow_handler::send_along(const packetflow_payload::ptr &msg)
{
    sst_throw(illformederror,
        "packetflow_handler::send_along: handler %s cannot send",
        to_string().c_str());
}

void
packetflow_handler::ack(const packetflow_payload::ptr &msg)
{
    sst_throw(illformederror,
        "packetflow_handler::send_along: handler %s cannot ack",
        to_string().c_str());
}

    }
}
