#ifndef NULLSCHEDULER_H
#define NULLSCHEDULER_H

#include <sstmac/hardware/processor/computescheduler.h>

namespace sstmac {
    namespace hw {

class nullscheduler :
    public computescheduler
{
    protected:
      nullscheduler(
        long nodeid,
        int ncores,
        int nsocket,
        timestamp preempt,
        const sw::operatingsystem::ptr& os);


    public:
        typedef boost::intrusive_ptr<nullscheduler> ptr;

        static ptr
        construct(
            long nodeid,
            int ncores,
            int nsocket,
            timestamp preempt,
            const sw::operatingsystem::ptr& os);

        void release(const sst_message::ptr &msg, long thread_id);

        void reserve(const sst_message::ptr &msg, long thread_id);

        void
        schedule_computation(const timestamp& comp,
              const sst_message::ptr& to_deliver,
              const eventhandler::ptr& handler,
              long thread_id);
};


    }
}

#endif // NULLSCHEDULER_H
