/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_HARDWARE_PROCESSOR_PROCESSOR_CONFIG_H_INCLUDED
#define SSTMAC_HARDWARE_PROCESSOR_PROCESSOR_CONFIG_H_INCLUDED


#include <sstmac/common/ptr_type.h>

namespace sstmac { namespace hw 
  {




  class processor_config : public ptr_type
  {
  public:
    enum PROC_MODELS {PROC_SIMPLE, PROC_INSTRUCTION};
    typedef boost::intrusive_ptr<processor_config> ptr;


  protected:

    processor_config(PROC_MODELS ptype, int n_cores) : proctype(ptype), n_cores_(n_cores)
    {

    }

  public:
    virtual std::string to_string() const{
      return "processor_config";
    }


    virtual
    ~processor_config();


    PROC_MODELS proctype;

    int n_cores_;
  };

  } } //end of namespace sstmac
#endif
