/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_MAIN_MULTISIM_H_INCLUDED
#define SSTMAC_MAIN_MULTISIM_H_INCLUDED

#include <sstmac/common/sim_parameters.h>

namespace sstmac
{
  namespace multisim
  {

    struct parameter_run
    {
      int num_;
      sstmac::sim_parameters::ptr params_;
    };
    void
    multisim_init(sstmac::sim_parameters::ptr params,
        std::vector<parameter_run> &runs, bool print);

    sstmac::sim_parameters::ptr
    do_multisim_fork(std::vector<parameter_run> &runs);
  }
}

#endif
