/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */


#include <sstmac/software/ami/hardware_descriptor.h>

#include <sstmac/common/errors.h>

namespace sstmac { namespace sw
{

  
  

hardware_descriptor::hardware_descriptor(int cores) :
    cores_(cores)
  {
  }

  hardware_descriptor::~hardware_descriptor()
  {
  }

  //
  // Allocate an object of this type.
  //
  hardware_descriptor::ptr
  hardware_descriptor::construct(int cores)
  {
    hardware_descriptor::ptr retval(new hardware_descriptor(cores));
   // retval->set_self(retval);
    return retval;
  }

} } //end of namespace sstmac
