/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/api/hpx/components/hpx_component.h>
#include <sstmac/software/api/hpx/hpx_app.h>

namespace hpx
{
  namespace components
  {
    sstmac::debug hpx_component::dbg_;

    void
    hpx_component::register_lib(sstmac::sw::library::ptr lib)
    {
      libs_.push_back(lib);
      hpx_app::hpx_register_lib(lib);
    }

    void
    hpx_component::unregister_libs()
    {
      std::list<sstmac::sw::library::ptr>::iterator it, end = libs_.end();
      for (it = libs_.begin(); it != end; it++)
      {
        curr_loc_->unregister_lib(*it);
      }
    }

    void
    hpx_component::reregister_libs()
    {
      std::list<sstmac::sw::library::ptr>::iterator it, end = libs_.end();
      for (it = libs_.begin(); it != end; it++)
      {
        curr_loc_->register_lib(*it);
      }
    }
  }
}
