/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_HPX_LCOS_FUTURE_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_HPX_LCOS_FUTURE_H_INCLUDED

#include <sstmac/software/api/hpx/lcos/promise.h>
#include <sstmac/software/api/hpx/runtime/hpx_thread.h>
#include <sstmac/software/api/hpx/runtime/actions/hpx_action_params.h>
#include <sstmac/software/api/hpx/runtime/hpx_thread_manager.h>
#include <sstmac/software/api/hpx/hpx_app.h>
namespace hpx
{
  namespace lcos
  {

    /**
     * This class doesn't do anything, it's just used as a thing you can wait on.
     */
    template<typename Result>
      class future : public promise<Result>
      {
      public:
        typedef boost::intrusive_ptr<future<Result> > ptr;

      protected:
        // ptr self_;

        future(boost::intrusive_ptr<hpx::parcels::depayloadizer<Result> > de) :
          promise<Result> (de)
        {

        }

      public:

        static ptr
        construct(
            boost::intrusive_ptr<hpx::parcels::depayloadizer<Result> > de =
                hpx::parcels::depayloadizer<Result>::construct())
        {
          return ptr(new future(de));
        }

        virtual
        ~future()
        {
        }

      };

  }
}

#endif
