#include <sstmac/software/api/hpx/lcos/local_mutex.h>

namespace hpx {
    namespace lcos {

      static sstmac::sw::key::category mutex_key_cat("HPX::lco::mutex");

      void
      local_mutex::lock()
      {
        SSTMAC_DEBUG << "hpx_local_mutex: locking, waiting size is "
              << waiting_.size() << "\n";
        if (locked_)
          {
            sstmac::sw::key::ptr blocker = sstmac::sw::key::construct(mutex_key_cat);
            waiting_.push(blocker);
            hpx_app::hpx_block(blocker);
           // hpx_app::hpx_thread_swap();
          }

        locked_ = true;
      }

      void
      local_mutex::unlock()
      {
        SSTMAC_DEBUG << "hpx_local_mutex: unlocking, waiting size is "
              << waiting_.size() << "\n";
        locked_ = false;

        if (waiting_.size() > 0)
          {
            sstmac::sw::key::ptr blocked = waiting_.front();
            waiting_.pop();
            hpx_app::hpx_unblock(blocked);

          }
      }
  }
}


