#include <sstmac/software/api/mpi/mpi_protocol/mpiprotocol.h>
#include <sstmac/software/api/mpi/mpiserver.h>

namespace sstmac {
    namespace sw {


void
eager0_protocol::recv_header(
    const mpiqueue::ptr &queue,
    const mpimessage::ptr &msg,
    const mpiqueue::recvrequest::ptr& req
)
{
    SSTMACBacktrace("MPI Eager 0 Protocol Recv Header");
    sst_throw(illformederror, "eager0 protocol should never have recv-request handle a header");
}

void
eager0_protocol::recv_payload(
    const mpiqueue::ptr &queue,
    const mpimessage::ptr &msg,
    const mpiqueue::recvrequest::ptr& req
)
{
}

bool
eager0_protocol::send_needs_eager_ack() const
{
    return false;
}

bool
eager0_protocol::send_needs_rendezvous_ack() const
{
    return false;
}

bool
eager0_protocol::send_needs_completion_ack() const
{
    return false;
}

bool
eager0_protocol::send_needs_nic_ack() const
{
    return true;
}

void
eager0_protocol::handle_payload(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
{
    sst_throw(illformederror, "eager protocol handling payload, but only headers should arrive");
}

bool
eager0_protocol::handshake_only() const
{
    return false;
}

    }
}
