#include <sstmac/software/api/mpi/mpi_protocol/mpiprotocol.h>
#include <sstmac/software/api/mpi/mpiserver.h>

namespace sstmac {
    namespace sw {


void
eager0_rdma::send_header(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
{
    SSTMACBacktrace("MPI Eager 0 Protocol: Send Header");
    queue->post_header(msg);
    SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
          << "]:: send_eager0_rdma_header done \n";
}

void
eager0_rdma::handle_header(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
{
    SSTMACBacktrace("MPI Eager 0 Protocol: Handle Header");
    mpiqueue::recvrequest::ptr req = queue->find_pending_request(msg);
    if (req)
        req->handle(msg);
    else
        queue->buffer_unexpected(msg);
    queue->notify_probes(msg);
    SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
          << "]:: handle_eager0_rdma_header done \n";
}

    }
}
