#include <sstmac/software/api/mpi/mpi_protocol/mpiprotocol.h>

namespace sstmac {
    namespace sw {

mpiprotocol::ptr mpiprotocol::eager0_mmap_protocol = new eager0_mmap;
mpiprotocol::ptr mpiprotocol::eager0_socket_protocol = new eager0_socket;
mpiprotocol::ptr mpiprotocol::eager0_rdma_protocol = new eager0_rdma;
mpiprotocol::ptr mpiprotocol::eager1_rdma_singlecpy_protocol = new eager1_rdma_singlecpy;
mpiprotocol::ptr mpiprotocol::eager1_rdma_doublecpy_protocol = new eager1_rdma_doublecpy;
mpiprotocol::ptr mpiprotocol::rendezvous_mmap_protocol = new rendezvous_mmap;
mpiprotocol::ptr mpiprotocol::rendezvous_socket_protocol = new rendezvous_socket;
mpiprotocol::ptr mpiprotocol::rendezvous_rdma_protocol = new rendezvous_rdma;
mpiprotocol::ptr mpiprotocol::creme_protocol = mpiprotocol::ptr();
mpiprotocol::ptr mpiprotocol::eager_ssend_protocol = new eager_ssend;
mpiprotocol::ptr mpiprotocol::rendezvous_rma_protocol = new rendezvous_rma;

bool mpiprotocol::statics_done_ = false;
debug mpiprotocol::dbg_;

void
mpiprotocol::init()
{
    if (statics_done_)
        return;

    if (!dbg_.is_real())
      {
        dbg_ = debug("<debug> mpi | mpiprotocol", logger::magenta);
        logger::register_logger(&dbg_);
      }
    statics_done_ = true;
}

void
mpiprotocol::handle_nic_ack(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
{
    if (msg->count() >= 0){
        queue->complete_nic_ack(msg);
    }
}

void
mpiprotocol::handle_payload(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
{
    sst_throw(illformederror, "%s should never handle payload", to_string().c_str());
}


    }
}
