#include <sstmac/software/api/mpi/mpi_protocol/mpiprotocol.h>
#include <sstmac/software/api/mpi/mpiserver.h>

namespace sstmac {
    namespace sw {

void
rendezvous_protocol::recv_header(
    const mpiqueue::ptr &queue,
    const mpimessage::ptr &msg,
    const mpiqueue::recvrequest::ptr& req
)
{
    //ack here
    queue->recv_needs_payload_[msg->id()] = req;
    queue->send_rendezvous_ack(msg);
}

bool
rendezvous_protocol::send_needs_eager_ack() const
{
    return false;
}

bool
rendezvous_protocol::send_needs_nic_ack() const
{
    return false;
}

bool
rendezvous_protocol::handshake_only() const
{
    return true;
}

   }
}
