/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/software/api/mpi/mpi_strategies/mpicorerecv.h>
#include <sstmac/software/api/mpi/mpi_queue/mpiqueue.h>
#include <sstmac/software/libraries/unblockhandler.h>
namespace sstmac { namespace sw
{

  // Pointer types.
  

  //
  // Hello.
  //
  mpicorerecv::mpicorerecv()
  {
  }

  //
  // Hello.
  //
  mpicorerecv::ptr
  mpicorerecv::construct()
  {
    return mpicorerecv::ptr (new mpicorerecv);
  }

  //
  // Goodbye.
  //
  mpicorerecv::~mpicorerecv() throw ()
  {
  }

  //
  // Post a receive request.
  //
  void
  mpicorerecv::execute(const mpirequest_t& req,
      const mpiqueue::ptr& queue, int count, const mpitype &type,
      const mpiid &source, const mpitag &tag, const mpicomm::ptr &comm,
      OS_API::ptr &os
  ) const
  {
    // return mpirecvengine::construct(thekey, queue, count, type, source,
    //                                tag, comm, mpimessage::user);
    eventhandler::ptr completion = queue->progress_done_handler(os, req);
    queue->recv(req, count, type, source, tag, comm, mpimessage::user, completion);
  }

} } // end of namespace sstmac
