/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/software/api/mpi/rma/mpiqueue-getrequest.h>
#include <sstmac/software/api/mpi/mpi_protocol/mpiprotocol.h>
#include <sstmac/software/api/mpi/mpimessage.h>
#include <sstmac/common/debug.h>
#include <sstmac/common/errors.h>

namespace sstmac
{
  namespace sw
  {

    // Pointer types.


    //
    // Hello.
    //
    mpiqueue::getrequest::getrequest(const mpirequest_t key,
        const mpiqueue::ptr& queue, const eventhandler::ptr &completion) :
      queue_(queue), key_(key), completion_(completion)
    {
    }

    //
    // We be done.
    //
    void
    mpiqueue::getrequest::handle(const mpimessage::ptr& mess)
    {
      key_->complete(mess);
      completion_->handle(mess);
    }

  }
} // end of namespace sstmac
