#ifndef SIMPMSG_H
#define SIMPMSG_H


#include <sstmac/software/process/app.h>
#include <sstmac/software/api/simpmsg/simple_message.h>

namespace simpmsg {


class simpmsg_thread :
    public sstmac::sw::thread
{
    private:
        static uint64_t num_threads_;

        sstmac::sw::lib_compute_time::ptr compute_;

        virtual void run() = 0;

    public:
        typedef boost::intrusive_ptr<simpmsg_thread> ptr;

        simpmsg_thread();

        void start();

        void compute(double sec);
};

void
simp_init();

void
simp_finalize();

int simp_rank();

int simp_nproc();

/**
    @param dst The destination to send to
*/
void
simp_send(int dst, const simple_message::ptr& msg);

void
simp_rdma_put(int dst, const simple_message::ptr& msg);

void
simp_rdma_get(int dst, const simple_message::ptr& msg);

simple_message::ptr
simp_poll();

void compute(double sec);

double
simp_time();

class simpmsg_api;
boost::intrusive_ptr<simpmsg_api>
simp_api();

}


#endif // SIMPMSG_H
