/*  lock.h                                                               */

#ifndef SSTMAC_UPC_lock_H_
#define SSTMAC_UPC_lock_H_

#include <sstmac/software/process/key.h>

#include <sstmac/common/ptr_type.h>
#include <sstmac/common/debug.h>

#include "sstmac_upc/server.h"

namespace sstmac
{
    namespace sw
    {
        namespace upc
        {
            class lock
            {
                private:
                    bool locked_;
                    key::ptr lock_holder_;
                    boost::unordered_map<key::ptr, server::ptr> servmap_;
                    
                public:
                    
                    lock() : locked_(false)
                    {
                    }
                    
                    virtual
                    ~lock()
                    {
                    }
                    
                    virtual std::string
                    to_string()
                    {
                        return "lock";
                    }
                    
                    bool
                    take_lock(key::ptr global_key);
                    
                    void
                    unlock(key::ptr global_key);
                    
                    void
                    add_server(key::ptr global_key, server::ptr serv);
                    
                    boost::unordered_map<key::ptr, server::ptr>&
                    get_servermap();
                    
            };
        }
    }
}

#endif
