/*  transfer_api.h                                                           */

#ifndef SSTMAC_SHMEM_transfer_api_H_
#define SSTMAC_SHMEM_transfer_api_H_

#include <sstmac/common/ptr_type.h>
#include <sstmac/common/messages/payload.h>

#include "sstmac_upc/memory/shared.h"
#include "sstmac_upc/messages/transfer.h"

namespace sstmac
{
  namespace sw
  {

    namespace upc
    {
      class transfer;

      class transfer_api : public virtual ptr_type
      {

      public:
        typedef boost::intrusive_ptr<transfer_api> ptr;
        
        virtual bool
        check_shared_heap(shared::ptr sobj) = 0;
        
        virtual void
        put_done(long tid) = 0;

        virtual void
        get_arrived(payload::const_ptr pay) = 0;

        virtual void
        send_put_complete(boost::intrusive_ptr<const transfer> t) const = 0;

        virtual void
        send_get_response(boost::intrusive_ptr<const transfer> t,
            payload::const_ptr pay) = 0;

        virtual void
        unblock() = 0;

      };
    }

  }
}
#endif
