/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */
#ifndef SSTMAC_SOFTWARE_LIBRARIES_MPIIO_MPIIO_FILE_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_MPIIO_MPIIO_FILE_H_INCLUDED

#include <sstmac/common/ptr_type.h>

namespace sstmac
{
  namespace sw
  {

    class mpiio_file : public ptr_type
    {
    public:
      typedef boost::intrusive_ptr<mpiio_file> ptr;

      static ptr
      construct(){
        return ptr(new mpiio_file());
      }

      virtual std::string
      to_string() const {
        return "mpiio_file";
      }

      virtual
      ~mpiio_file();

    protected:
      mpiio_file();
    };

  }
}
#endif /* MPIIO_FILE_H_ */
