/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2011 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/libraries/topomap/topomap.h>

#include <sstmac/software/libraries/topomap/topomap_api.h>
#include <sstmac/software/process/os_api.h>
#include <sstmac/software/process/thread.h>




using namespace sstmac;
using namespace sstmac::sw;


topomap_api::ptr
get_api() {
  thread::ptr t = OS_API::get_current_thread();
  return t->get_api<topomap_api>();
}

extern "C" MPI_Comm
TPM_COMM_WORLD()
{
  return get_api()->tpm_comm();
}

extern "C" int
TPM_rank()
{
  return get_api()->tpm_rank();
}

extern "C" void
TPM_Init(bool usetopo)
{
  get_api()->tpm_init(usetopo);
}

