#include <sstmac/software/process/api.h>
#include <sstmac/common/errors.h>

namespace sstmac {
    namespace sw {

int APIBase::id_counter = 0;
std::map<std::string, int>* APIBase::name_to_id = 0;

int
APIBase::api_id(const std::string &name)
{
    std::map<std::string,int>::const_iterator it
        = name_to_id->find(name);
    if (it == name_to_id->end()){
        sst_throw(valueerror, "invalid api name %s", name.c_str());
    }
    return it->second;
}

    }
}
