/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <stdlib.h>

#include <sstmac/common/sstmac-config.h>

#include <sstmac/software/process/operatingsystem.h>

#include <sstmac/software/process/app.h>
#include <sstmac/software/process/key.h>
#include <sstmac/software/ami/environment.h>
#include <sstmac/common/messages/sst_message.h>
#include <sstmac/common/eventcallback.h>

#include <sstmac/software/threading/threading_pth.h>
#include <sstmac/software/threading/threading_pthread.h>
#include <sstmac/software/threading/threading_ucontext.h>

#include <sstmac/software/services/service.h>
#include <sstmac/hardware/processor/computescheduler.h>

namespace sstmac
{
  namespace sw
  {

  eventmanager::ptr
  OS_API::get_eventmanager() const
  {
      return eventman_;
  }

  void
  OS_API::set_eventmanager(const eventmanager::ptr& man)
  {
    eventman_ = man;
  }

  thread::ptr
  OS_API::get_current_thread()
  {
    return current_thread_;
  }

  OS_API::~OS_API()
  {
  }

  void
  OS_API::clear_statics(){
      operatingsystem::clear_statics();
      current_thread_ = 0;
  }

  }
}

