#include <sstmac/software/process/tasklist.h>

namespace sstmac {
    namespace sw {

    taskid
    tasklist::at(unsigned int i) const
    {
      if (i > list_.size()){
        sst_throw(rangeerror, "value %u out of range for tasklist of size %lu",
                  i, list_.size());
      }
      else
        return list_[i];
    }

    bool
    tasklist::equals(const tasklist::ptr &other) const
    {
      bool same = list_.size() == other->list_.size();
      for (uint i = 0; i < list_.size() && same; i++)
        {
        same = same && (list_[i] == other->list_[i]);
      }
    return same;
  }

    bool
    tasklist::equals(const std::vector<taskid> &other) const
    {
      bool same = list_.size() == other.size();
      for (uint i = 0; i < list_.size() && same; i++)
        {
        same = same && (list_[i] == other[i]);
      }
    return same;
  }

    }
}
