#ifndef USER_APP_H
#define USER_APP_H

#include <sstmac/software/process/app.h>

namespace sstmac
{
  namespace sw
  {

    class user_app : public app
    {
    public:
      typedef boost::intrusive_ptr<user_app> ptr;

      typedef boost::intrusive_ptr<const user_app> const_ptr;

    protected:
      /** Constructor - pass along arguments to parent mpi class */
      user_app(sstmac::sw::softwareid id)
          : app(id)
      {
      }

      user_app(const sim_parameters::ptr& params) : app(params) {}

    public:
      /** Destructor - do nothing */
      virtual ~user_app() throw () {}

      virtual void
      init_factory_params(const sim_parameters::ptr &params);

      virtual void skeleton_main() = 0;

    };

  } //end namespace sw
} //end namespace sstmac


#endif // USER_APP_H
