/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2011 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/software/process/user_app_cxx.h>
#include <sstmac/software/process/graphviz.h>

int user_skeleton_main(int argc, char **argv);
void consume_parameters(const sstmac::sim_parameters::ptr &params);

namespace sstmac
{
  namespace sw
  {
    SSTRegister("c++ | CXX | C++ | cxx | user_app_cxx | user_mpiapp_cxx | user_shmemapp_cxx | user_upcapp_cxx", app, user_app_cxx,
                "default application for linking to external C++ skeleton apps");

    void user_app_cxx::skeleton_main() {
        SSTMACBacktrace("main");
        user_skeleton_main(get_argc(), get_argv());
    }

    void user_app_cxx::consume_params(
        const sstmac::sim_parameters::ptr &params) {
      consume_parameters(params);
    }

  } //end namespace sw
} //end namespace sstmac






