/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/skeletons/test/global_test.h>

namespace sstmac
{
  namespace sw
  {
    SSTRegister("global_test | test_global", app, global_test);


    //either initialization mechanism works, apparently.
    global_int global_test::class_global_(9);
    global_double global(10);

    void
    global_test::consume_params(const sim_parameters::ptr &params)
    {

    }

    void
    global_test::skeleton_main()
    {
      SSTMAC_DEBUG << "Hello World! AppID = " << id_.app_.id << ", my id = "
            << id_.task_.id << ", I'm located at "
            << get_physical_address()->to_string()
            << ", and I have initial value of " << class_global_
            << " for my class global, and an initial value of " << global
            << " for the file global.\n";

      class_global_ = id_.task_.id;
      global = id_.task_.id;

      SSTMAC_DEBUG << "class global after assignment: " << class_global_
            << "\n";
      SSTMAC_DEBUG << "file global after assignment: " << global << "\n";

      timestamp t(rand() % 20);
      sleep(t);

      class_global_ = class_global_ + 1;
      global = global + 1;

      SSTMAC_DEBUG << "test(" << id_.task_.id << "): added one to class: " << class_global_ << "\n";
      SSTMAC_DEBUG << "test(" << id_.task_.id << "): added one to file: " << global << "\n";


    }

  }
} //end of namespace sstmac
