#include <sstmac/common/test/test.h>
#include <sstmac/software/process/app.h>
#include <sstmac/software/process/operatingsystem.h>
#include <sstmac/software/api/simpmsg/simpmsg.h>
#include <sstmac/software/api/simpmsg/sstmac_simpmsg_api.h>
#include <sstmac/hardware/network/topology/traffic/traffic.h>
#include <sstmac/keywords/keyword_registration.h>

using namespace sstmac;
using namespace sstmac::hw;
using namespace sstmac::sw;

StaticNumberedKeywordRegister reg(400, "partner_%d");

namespace simpmsg {

sstmac_register_app(test_train_traffic)

int
test_train_traffic_main(int argc, char** argv)
{
    simp_init();

    int nmsg = sstmac_env::params->get_optional_int_param("num_messages", 3);
    int num_bytes = sstmac_env::params->get_byte_length_param("message_length");

    int me = simp_rank();
    std::string param_name = sstprintf("partner_%d", me);
    int dst = sstmac_env::params->get_optional_int_param(param_name, -1);

    if (dst >= 0){
        for (int i=0; i < nmsg; ++i){
            simple_message::ptr msg = new simple_message(num_bytes);
            simp_rdma_put(dst, msg);
        }
    }

    simp_finalize();
}

}

