#include <tests/unittests/util/util.h>


void test_torus(UnitTest& unit);
void test_crossbar(UnitTest& unit);
void test_fattree2(UnitTest& unit);
void test_fattree4(UnitTest& unit);
void test_butterfly(UnitTest& unit);
void test_fbfly(UnitTest& unit);
void test_dragonfly_v1(UnitTest& unit);
void test_dragonfly_v2(UnitTest& unit);

using namespace sstmac;

int main(int argc, char** argv)
{
    native::nodeid::init_statics();

    UnitTest unit;
    try{
        std::cout << "Testing torus...\n";
            test_torus(unit);
        std::cout << "Testing fat tree...\n";
            test_fattree2(unit);
            test_fattree4(unit);
        std::cout << "Testing crossbar...\n";
            test_crossbar(unit);
        std::cout << "Testing butterfly...\n";
            test_butterfly(unit);
        std::cout << "Testing fbfly...\n";
            test_fbfly(unit);
        std::cout << "Testing dragonfly...\n";
            test_dragonfly_v1(unit);
            test_dragonfly_v2(unit);
        unit.validate();
    } catch (std::exception& e) {
        std::cerr << e.what() << std::endl;
    }

    return 0;
}
