#include "test_topology.h"
#include <sstmac/backends/native/nodeid.h>

using namespace sstmac;
using namespace sstmac::hw;

int main(int argc, char** argv)
{
    native::nodeid::init_statics();

    UnitTest unit;

    try{
        std::cout << "Testing torus...\n";
           test_torus_traffic(unit);
           test_torus(unit);
           test_torus_valiant(unit);
        std::cout << "Testing fat tree...\n";
            test_fattree2(unit);
            test_fattree4(unit);
        std::cout << "Testing crossbar...\n";
            test_crossbar(unit);
        std::cout << "Testing butterfly...\n";
            test_butterfly(unit);
        std::cout << "Testing fbfly...\n";
            test_fbfly(unit);
        std::cout << "Testing dragonfly...\n";
            test_dragonfly_traffic(unit);
            test_dragonfly_v1(unit);
            test_dragonfly_v2(unit);
        unit.validate();
    } catch (std::exception& e) {
        std::cerr << e.what() << std::endl;
    }

    return 0;
}
