#!/usr/bin/env python

import re

# precompile regex for entry begin and end
re_begin = re.compile(r'<!\[CDATA')
re_end = re.compile(r'\]\]>')
re_name = re.compile(r'<Entry name="(.*?)">')


def extract_data(file_path):

    """Extract data entries from trace analysis report"""

    # a dictionary with entry name as the key and 2d array as value
    entry_dict = {}
    cdata = False
    f = open(file_path)
    for line in f:
        if not cdata:
            m = re_name.match(line)
            if m:
                entry_name = m.group(1)
            if re_begin.match(line):   # locate the start of the data
                cdata = True
                rows = []
        elif cdata and re_end.match(line):    # convert nested list into matrix
            entry_dict[entry_name] = rows
            cdata = False
        elif cdata and line.rstrip():
            rows.append([i.strip() for i in line.split(',')])
    return entry_dict


def safe_float(s):
    try:
        return float(s)
    except ValueError:
        return s

def main():
    """testing main function"""

    dat = extract_data('original_64.xml')


if __name__ == '__main__':
    main()
