#!/usr/bin/env python

import os
import re
import traceanalysis as tat


def plot_overall(entry, conf, script_file, data_file):
    """docstring for plot_perprocess"""
    pass


def plot_bynode(entry, conf, script_file, data_file):
    """docstring for plot_perprocess"""
    print 'generating data file: ' + data_file
    plot_data = [(c,) + zip(*e)[2] for e, c in zip(entry, conf)]
    plot_data = zip(*plot_data)
    write_plot_data(plot_data, data_file)

    f = open('visual/plotperprocess')
    fo = open(script_file, 'a')
    for line in f:
        line = re.sub(r'<data>', data_file, line)
        fo.write(line)
    f.close()
    fo.close()


def plot_mpicall(entry, conf, script_file, data_file):
    """docstring for plot_perprocess"""

    pass


def plot_collective(entry, conf, script_file, data_file):
    """docstring for plot_perprocess"""
    pass


def plot_transmission(entry, conf, script_file, data_file):
    """docstring for plot_perprocess"""
    pass


def write_plot_data(array, path):
    """write the 2d array data into file as CSV"""
    f = open(path, 'wb')
    for a in array:
        f.write(', '.join(a))
        f.write(',\n')
    f.close()
    pass


def create_plot_script(output, script):
    """docstring for create_plot_script"""

    print 'creating plot script: ' + script
    f = open('visual/plotscriptbase')
    fo = open(script, 'wb')
    for line in f:
        line = re.sub(r'<output>', output, line)
        fo.write(line)
    f.close()
    fo.close()


def invoke_gnuplot(script):
    """docstring for invoke_gnuplot"""

    print 'invoking gnuplot using script: ' + script
    pipe = os.popen('gnuplot {0}'.format(script))


def plot_data(dat, conf, output):
    """plot trace analysis data"""

    plotter_map = {'Overall': plot_overall,
                   'ByNode': plot_bynode,
                   'MpiCall': plot_mpicall,
                   'Collective': plot_collective,
                   'Transmission': plot_transmission}

    output = os.path.abspath(output)
    output_file, output_ext = os.path.splitext(output)
    plot_script = output_file + '.gnuplot'
    create_plot_script(output, plot_script)
    for k in dat[0].keys():
        entry = [d[k] for d in dat]
        plot_data = output_file + '.{0}'.format(k.lower())
        plotter_map[k](entry, conf, plot_script, plot_data)
    invoke_gnuplot(plot_script)


def main():
    """testing main function"""

    dat = tat.extract_data('original_64.xml')
    plot_data([dat], ['original'],  'original_64.pdf')


if __name__ == '__main__':
    main()
