//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_ANALYZER_METADATA
#define SSTMAC_TOOLS_ANALYZER_METADATA

#include "common/stats/stats.h"

namespace sstmac { namespace tools { namespace analyzer {

// MetaData is the in memory representation of dumpi trace metafile
class MetaData : public StatsMeta 
{
public:
    // Load key/value pairs from metafile into container
    bool Read(const std::string& filePath);

    // Return value associated with key
    template<typename T>
    T GetValue(const std::string& key) const;
};

} } } //namespace

#include "analyzer/trace/meta/metadata.hh"

#endif //SSTMAC_TOOLS_ANALYZER_METADATA
