//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_ANALYZER_TRACE_NODE_NODEDATA_INCLUDED_
#define SSTMAC_TOOLS_ANALYZER_TRACE_NODE_NODEDATA_INCLUDED_

#include <string>
#include "analyzer/trace/node/context/mpicontext.h"
#include "analyzer/trace/node/callback/callback.h"

namespace sstmac { namespace tools { namespace analyzer {

class CallRecordBase;
  
class NodeData : public MPIContext
{
public:
    NodeData(int nodeRank, int worldSize);
    virtual ~NodeData();
    
    bool SetFilePath(const std::string& filePath);
    bool Parse(const RecordCallback& callback);

private:
    std::string m_filePath;
};

} } } //namespace

#endif //SSTMAC_TOOLS_ANALYZER_TRACE_NODE_NODEDATA_INCLUDED_
