//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#include "analyzer/trace/node/record/callrecordbase.h"
#include "analyzer/trace/node/context/mpicontext.h"

namespace sstmac { namespace tools { namespace analyzer {

CallRecordBase::CallRecordBase(MPIContext* context, int function, TimeRange cpuTime, TimeRange wallTime)
    : m_context(context)
    , m_function(function)
    , m_cpuTime(cpuTime)
    , m_wallTime(wallTime)
{}

CallRecordBase::~CallRecordBase()
{}

int CallRecordBase::GetNodeRank() const
{
    return m_context->GetWorldRank();
}

int CallRecordBase::GetFunction() const
{
    return m_function;
}

TimeRange CallRecordBase::GetCpuTime() const
{
    return m_cpuTime;
}

TimeRange CallRecordBase::GetWallTime() const
{
    return m_wallTime;
}

} } } //namespace
