//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#include "common/commoninitializer.h"
#include "common/factory/factory.h"
#include "common/utilities/dumpihelper.h"
#include "common/stats/entry/entrydatabase.h"
#include "common/comparison/criterion/criteriondatabase.h"

void EntryDataUsingClass()
{
    FACTORY_USING_CLASS(EntryDataBase, Overall);
    FACTORY_USING_CLASS(EntryDataBase, ByNode);
    FACTORY_USING_CLASS(EntryDataBase, MpiCall);
    FACTORY_USING_CLASS(EntryDataBase, Collective);
    FACTORY_USING_CLASS(EntryDataBase, TransmissionTime);
    FACTORY_USING_CLASS(EntryDataBase, TransmissionBytes);
}

void CriterionDataUsingClass()
{
    FACTORY_USING_CLASS(CriterionDataBase, Overall);
    FACTORY_USING_CLASS(CriterionDataBase, ByNode);
    FACTORY_USING_CLASS(CriterionDataBase, MpiCall);
    FACTORY_USING_CLASS(CriterionDataBase, Collective);
    FACTORY_USING_CLASS(CriterionDataBase, TransmissionBytes);
}

namespace sstmac { namespace tools {

CommonInitializer::CommonInitializer()
{
    EntryDataUsingClass();
    CriterionDataUsingClass();

    Dumpi::Init();
}

CommonInitializer::~CommonInitializer()
{
    FACTORY_DESTROY(sstmac::tools, EntryDataBase);
    FACTORY_DESTROY(sstmac::tools, CriterionDataBase);
}

} } //namespace
