//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_COMPARISON_CRITERIONDATABASE_INCLUDED_
#define SSTMAC_TOOLS_COMMON_COMPARISON_CRITERIONDATABASE_INCLUDED_

#include <sstream>
#include <boost/shared_ptr.hpp>
#include "common/utilities/serializehelper.h"
#include "common/utilities/classhelper.h"

namespace sstmac { namespace tools {

#define DECLARE_CRITERIONDATA(TYPE) \
    CLASS_ID(TYPE); \
    DECLARE_SERIALIZABLE_VIRTUAL(TYPE); \
    typedef boost::shared_ptr<TYPE> Ptr; \
    typedef statsentry::TYPE EntryDataType; \
    typedef EntryDataType::Ptr EntryDataPtr

struct CriterionDataBase 
{
    CLASS_ID(CriterionDataBase);

    DECLARE_SERIALIZABLE_PUREVIRTUAL(CriterionDataBase);
    
    typedef boost::shared_ptr<CriterionDataBase> Ptr;

    CriterionDataBase();
    virtual ~CriterionDataBase();
    
    float m_logicSimilarity;
    float m_numericSimilarity;
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_COMPARISON_CRITERIONDATABASE_INCLUDED_
