//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON__LOGGER
#define SSTMAC_TOOLS_COMMON__LOGGER

#include <cstdio>

namespace sstmac { namespace tools { 

bool IsVerbose();

void SetVerbose(bool verboseFlag);

} } //namespace 

#define OUTPUT_INFO(...)                        \
    fprintf(stdout,  __VA_ARGS__);              \

#define OUTPUT_LOG(...)                         \
    if (IsVerbose())                            \
    {                                           \
        fprintf(stdout, "[LOG] " __VA_ARGS__);  \
    }

#define OUTPUT_WARNING(...)                     \
    fprintf(stderr, "[WARNING] " __VA_ARGS__);  \

#define OUTPUT_ERROR(...)                       \
    fprintf(stderr, "[ERROR] " __VA_ARGS__);    \

#define OUTPUT_LOG_IF(cond, ...)    \
    if (cond)                       \
    {                               \
        OUTPUT_LOG(__VA_ARGS__)     \
    }

#define OUTPUT_WARNING_IF(cond, ...)    \
    if (cond)                           \
    {                                   \
        OUTPUT_WARNING(__VA_ARGS__)     \
    }

#define OUTPUT_ERROR_IF(cond, ...)  \
    if (cond)                       \
    {                               \
        OUTPUT_ERROR(__VA_ARGS__)   \
    }

#endif //SSTMAC_TOOLS_COMMON_LOG_LOGGER
