//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_META_ISCLASS_INCLUDED_
#define SSTMAC_TOOLS_COMMON_META_ISCLASS_INCLUDED_

#include "common/meta/meta.h"

namespace sstmac { namespace tools {

//////////////////////////////////////////////////////////////////////////
/// Answer is true if the provided Type is a class
/// 
/// class MyClass{};
///
/// IsClass< MyClass >::Answer == true
/// IsClass< Int >::Answer == false
/// 
//////////////////////////////////////////////////////////////////////////
template< typename Type >
struct IsClass
{
private:

    template< typename AnswerYes > 
    static Yes Tester( void(AnswerYes::*)(void) );

    template< typename AnswerNo > 
    static No Tester( ... );

public:
    enum
    {
        Result = sizeof( Tester<Type>(0) ) == sizeof( Yes )
    };
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_META_ISCLASS_INCLUDED_
