//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_ACCUMULATOR_ACCUMULATORIMPL_INCLUDED_
#define SSTMAC_TOOLS_COMMON_ACCUMULATOR_ACCUMULATORIMPL_INCLUDED_

#include "common/numeric/accumulatorbase.h"

namespace sstmac { namespace tools {

////////////////////////////////////////////////////////////////////////////////
// Sum
class Sum : public AccumulatorBase
{
public:
    Sum();

    virtual void Accumulate(double val);
    virtual double Evaluate() const;

private:
    double m_sum;
};

////////////////////////////////////////////////////////////////////////////////
// Average
class Average : public AccumulatorBase 
{
public:
    Average();

    virtual void Accumulate(double val);
    virtual double Evaluate() const;

private:
    double m_sum;
    unsigned int m_count;
};

////////////////////////////////////////////////////////////////////////////////
// Deviation
class Deviation : public AccumulatorBase
{
public:
    Deviation();
    
    virtual void Accumulate(double val);
    virtual double Evaluate() const;

private:
    double m_mean;
    double m_m2;
    unsigned int m_count;
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_ACCUMULATOR_ACCUMULATORIMPL_INCLUDED_
