//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_REPORT_REPORTSTATS_INCLUDED_
#define SSTMAC_TOOLS_COMMON_REPORT_REPORTSTATS_INCLUDED_

#include "common/report/reportbase.h"

namespace sstmac { namespace tools {

class Stats;
class EntryDataBase;

class ReportStats : public ReportBase 
{
public:
    typedef EntryDataBase* (*EntryCreator)(const std::string&);

public:
    //function poiter EntryCreator determines the concrete entry type: plot entry or normal entry
    ReportStats (Stats& stats, EntryCreator entryCreator = DefaultEntryCreator);

private:
    bool ReadImpl(std::istream& is);
    bool WriteImpl(std::ostream& os) const;

    static EntryDataBase* DefaultEntryCreator(const std::string& classId);

private:
    Stats& m_stats;
    EntryCreator m_entryCreator;

    static const char* ROOT_TAG;
    static const char* META_TAG;
    static const char* STATS_TAG;
    static const char* STATS_ATTR_COUNT;
    static const char* ENTRY_TAG;
    static const char* ENTRY_ATTR_NAME;
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_REPORT_REPORTSTATS_INCLUDED_
