//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_STATS_ENTRYDATABASE_INCLUDED_
#define SSTMAC_TOOLS_COMMON_STATS_ENTRYDATABASE_INCLUDED_

#include <boost/shared_ptr.hpp>
#include "common/utilities/serializehelper.h"
#include "common/utilities/classhelper.h"

namespace sstmac { namespace tools {

#define DECLARE_ENTRYDATA(TYPE) \
    CLASS_ID(TYPE); \
    DECLARE_SERIALIZABLE_VIRTUAL(TYPE); \
    typedef boost::shared_ptr<TYPE> Ptr; \

struct EntryDataBase 
{
    CLASS_ID(EntryDataBase);

    DECLARE_SERIALIZABLE_PUREVIRTUAL(EntryDataBase);
    
    typedef boost::shared_ptr<EntryDataBase> Ptr;

    virtual ~EntryDataBase();
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_STATS_ENTRYDATABASE_INCLUDED_
