#ifndef _VARIADICMACROHELPER_INCLUDED_S1P7LYFY
#define _VARIADICMACROHELPER_INCLUDED_S1P7LYFY

#include <boost/preprocessor/repetition/repeat.hpp>
#include <boost/preprocessor/array/elem.hpp>

//////////////////////////////////////////////////////////////////////////
// Count the number of arguments in __VA_ARGS__
// From http://groups.google.com/group/comp.std.c/browse_thread/thread/77ee8c8f92e4a3fb/346fc464319b1ee5?pli=1
// Calculate number of arguments in the Variadic macro
// Max count = 15, increase the count if needed by add more numbers
// Example:
// PP_NARG(A) -> 1 
// PP_NARG(A,B) -> 2 
// PP_NARG(A,B,C) -> 3 

#define PP_NARG(...) PP_NARG_(__VA_ARGS__, PP_ARG_PADDINPP_COMMA_IF_NOTEMPTY(__VA_ARGS__)G())

#define PP_NARG_(...) PP_ARG_N( __VA_ARGS__) 

#define PP_ARG_N(_01,_02,_03,_04,_05,_06,_07,_08,_09,_10,_11,_12,_13,_14,_15,N,...) N

#define PP_ARG_PADDING() 15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0

//////////////////////////////////////////////////////////////////////////
// For each will process every single element inside __VA_ARGS__
// Example:
// #define _EXAMPLE(n, i, data) abs(BOOST_PP_ARRAY_ELEM( i, data ));
// FOREACH_VARIADIC(_EXAMPLE, a, b, c) will expand to abs(a); abs(b); abs(c);

#define VARIADIC_ARRAY( ... ) ( PP_NARG(__VA_ARGS__) , ( __VA_ARGS__ ) )

#define FOREACH_VARIADIC( A, ... ) BOOST_PP_REPEAT ( PP_NARG(__VA_ARGS__), A, VARIADIC_ARRAY(__VA_ARGS__) )

#endif //SSTMAC_TOOLS_COMMON_VARIADICMACROHELPER
