//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_VISUALIZER_PLOT_ENTRYPLOTBASE_INCLUDED_
#define SSTMAC_TOOLS_VISUALIZER_PLOT_ENTRYPLOTBASE_INCLUDED_

#include "common/utilities/classhelper.h"
#include "common/stats/entry/entrydatabase.h"
#include "visualizer/plot/plotbase.h"

#define DECLARE_ENTRYPLOT(TYPE) \
class EntryPlot##TYPE : public EntryPlotBase \
                      , public statsentry::TYPE \
{ \
public: \
    CLASS_ID(TYPE); \
    typedef boost::shared_ptr<TYPE> Ptr; \
    virtual void Plot(plstream* pls); \
}

namespace sstmac { namespace tools { namespace visualizer {

class EntryPlotBase : public PlotBase
{
public:
    CLASS_ID(EntryPlotBase);

    typedef boost::shared_ptr<EntryPlotBase> Ptr;
};

} } } //namespace

#endif //SSTMAC_TOOLS_VISUALIZER_PLOT_ENTRYPLOTBASE_INCLUDED_
