//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_VISUALIZER_UI_PLOTFRAME_INCLUDED_
#define SSTMAC_TOOLS_VISUALIZER_UI_PLOTFRAME_INCLUDED_

#include <vector>
#include <wx/docview.h>
#include <wx/scrolwin.h>
#include <wxPLplotwindow.h>
#include "visualizer/ui/uidefines.h"
#include "visualizer/plot/plotbase.h"

namespace sstmac { namespace tools { namespace visualizer {

////////////////////////////////////////////////////////////////////////////////
// 
class PlotWindow : public wxPLplotwindow
{
public:
    PlotWindow (wxWindow* parent, PlotBase::Ptr plot);

    wxString GetPlotName() const;

    void PlotToDC();
    bool PlotToFile(const wxString& dev, const wxString& filePath);

private:
    void Plot(plstream* pls);

private:
    PlotBase::Ptr m_plot;
};

////////////////////////////////////////////////////////////////////////////////
// 
class PlotScrollWindow : public wxScrolledWindow
{
public:
    PlotScrollWindow (wxWindow* parent);
};

////////////////////////////////////////////////////////////////////////////////
//
class PlotFrame : public wxDocChildFrame
{
    DECLARE_EVENT_TABLE();

public:
    PlotFrame (wxDocument* document, wxView* view, wxDocParentFrame* parent, const wxString& title);

    void AddPlotWindow(PlotBase::Ptr plot);

private:
    void CreateMenuBar();

    void OnMenuExport(wxCommandEvent& cmd);

private:
    PlotScrollWindow* m_scrollWindow;
    std::vector<PlotWindow*> m_plotWindows;
};

} } } //namespace

#endif //SSTMAC_TOOLS_VISUALIZER_UI_PLOTFRAME_INCLUDED_
