#include <sstmac/sstmpi.h>
#include <sstmac/util.h>

sim_parameters::ptr params_ = NULL;

void consume_parameters(const sim_parameters::ptr &params) {
    params_ = params;
}

int user_skeleton_main(int argc, char **argv) {

    int me, nproc;
    int tag(0);
    int dst(1);
    int src(0);
    MPI_Status stat;

    int message_size = params_->get_int_param("sendrecv_message_size");
  
    MPI_Init(&argc,&argv);
    MPI_Comm world = MPI_COMM_WORLD;
    MPI_Comm_rank(world,&me);
    MPI_Comm_size(world,&nproc);
    
    if (me == 0 && nproc != 2)
        throw inputerror("sendrecv should only be run with two processors");

    if (me == 0) {
        MPI_Send(NULL, message_size, MPI_INT, dst, tag, world);
        printf("rank %i sending a message\n", me);
    }
    else {
        MPI_Recv(NULL, message_size, MPI_INT, src, tag, world, &stat);
        printf("rank %i receiving a message\n", me);
    }

    MPI_Finalize();

    return 0;
}

